'use strict';
function Main() {
  if (Number(Left(LastSchoolDayCovered, 4)) < Year(CDate(new Date())) + 1) {
    NSB.MsgBox("Calendar needs to be updated");
  }
  ChangeForm(ScheduleForm);
}
var ScheduleArray = createMultiDimArray("");
var SCHEDYEAR = 0;
var SCHEDMONTH = 1;
var SCHEDDAY = 2;
var SCHEDWEEKDAY = 3;
var SelectedYear;
var SelectedMonth;
ScheduleForm.onshow = function () {
  var Row, Col;
  var ColWidth = Math.floor(ScreenWidth / 7) - 1;
  for (Col = 0; Col <= 6; Col++) {
    DateGrid.setColumnWidth(Col, ColWidth + "px");
  }
  for (Row = 0; Row <= 6; Row++) {
    DateGrid.setRowHeight(Row, "52px");
  }
  DateGrid.Width = ColWidth * 7 + 2;
  DateGrid.style.tableLayout = "fixed";
  DateGrid.style.textAlign = "center";
  DateGrid.Left = CenterInForm(SysInfo(0), DateGrid.Width);
  EPSBLabel.Left = DateGrid.Left;
  MonthLabel.Width = DateGrid.Width;
  MonthLabel.Left = DateGrid.Left;
  Back1YearButton.Top = DateGrid.Top + DateGrid.Height + 4;
  Back1MonthButton.Top = Back1YearButton.Top;
  CurrentButton.Top = Back1YearButton.Top;
  Forward1MonthButton.Top = Back1YearButton.Top;
  Forward1YearButton.Top = Back1YearButton.Top;
  Back1YearButton.Left = DateGrid.Left;
  Back1MonthButton.Left = Back1YearButton.Left + Back1YearButton.Width + 5;
  Forward1YearButton.Left =
    DateGrid.Left + DateGrid.Width - Forward1YearButton.Width;
  Forward1MonthButton.Left =
    Forward1YearButton.Left - Forward1MonthButton.Width - 5;
  CurrentButton.Left = CenterInForm(SysInfo(0), CurrentButton.Width);
  ContactsButton.Left = ScreenWidth - 95;
  var DaysInMonth = [0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  var MonthDays, DayOfWeek;
  var ScheduleYear, ScheduleMonth, ScheduleDay;
  var EndYear, EndMonth;
  var End;
  ScheduleArray = [];
  ScheduleYear = Number(Left(FirstSchoolDayCovered, 4));
  EndYear = Number(Left(LastSchoolDayCovered, 4));
  ScheduleMonth = Number(Mid(FirstSchoolDayCovered, 5, 2));
  EndMonth = Number(Mid(LastSchoolDayCovered, 5, 2));
  if (
    Year(CDate(new Date())) < ScheduleYear ||
    (Year(CDate(new Date())) == ScheduleYear &&
      Month(CDate(new Date())) < ScheduleMonth)
  ) {
    SelectedYear = ScheduleYear;
    SelectedMonth = ScheduleMonth;
  } else if (
    Year(CDate(new Date())) > EndYear ||
    (Year(CDate(new Date())) == EndYear && Month(CDate(new Date())) > EndMonth)
  ) {
    SelectedYear = EndYear;
    SelectedMonth = EndMonth;
  } else {
    SelectedYear = Year(CDate(new Date()));
    SelectedMonth = Month(CDate(new Date()));
  }
  do {
    if (ScheduleMonth == 2 && ScheduleYear % 4 == 0) {
      MonthDays = 29;
    } else {
      MonthDays = DaysInMonth[ScheduleMonth];
    }
    for (ScheduleDay = 1; ScheduleDay <= MonthDays; ScheduleDay++) {
      DayOfWeek = Weekday(
        ScheduleMonth + "/" + ScheduleDay + "/" + ScheduleYear
      );
      Push(ScheduleArray, [
        ScheduleYear,
        ScheduleMonth,
        ScheduleDay,
        DayOfWeek,
      ]);
    }
    if (ScheduleYear == EndYear && ScheduleMonth == EndMonth) {
      break;
    }
    ScheduleMonth = ScheduleMonth + 1;
    if (ScheduleMonth > 12) {
      ScheduleMonth = 1;
      ScheduleYear = ScheduleYear + 1;
    }
  } while (0 < 1);
  DisplayScheduleForm();
};

var Months = [
  "",
  "January",
  "February",
  "March",
  "April",
  "May",
  "June",
  "July",
  "August",
  "September",
  "October",
  "November",
  "December",
];

function DisplayScheduleForm() {
  var Row, Col;
  MonthLabel.text = Months[SelectedMonth] + " " + SelectedYear;
  for (Row = 1; Row <= 6; Row++) {
    for (Col = 0; Col <= 6; Col++) {
      DateGrid.cell(Row, Col).style.backgroundColor = "#FFFFFF";
      DateGrid.cell(Row, Col).style.color = "#000000";
      DateGrid.cell(Row, Col).style.fontWeight = "normal";
      DateGrid.cell(Row, Col).style.fontSize = "20px";
      DateGrid.cell(Row, Col).style.fontStyle = "normal";
      DateGrid.setValue(Row, Col, "&nbsp;");
    }
  }

  var Start, i, j;
  //  Start = ((SelectedYear - Year(Date)) * 365) + ((SelectedMonth - 1) * 29) 'Position close to current selection to save number of entries to scan
  for (i = 0; i <= Len(ScheduleArray) - 1; i++) {
    if (
      ScheduleArray[i][SCHEDYEAR] == SelectedYear &&
      ScheduleArray[i][SCHEDMONTH] == SelectedMonth
    ) {
      Start = i;
      break;
    }
  }

  var GridRow = 1;
  var SelectedDate, SpecialDay;
  for (i = Start; i <= Len(ScheduleArray) - 1; i++) {
    if (
      ScheduleArray[i][SCHEDYEAR] == SelectedYear &&
      ScheduleArray[i][SCHEDMONTH] == SelectedMonth
    ) {
      SelectedDate = CDate(
        SelectedMonth + "/" + ScheduleArray[i][SCHEDDAY] + "/" + SelectedYear
      );
      SelectedDate = FormatDateTime(SelectedDate, 5);
      DateGrid.setValue(
        GridRow,
        ScheduleArray[i][SCHEDWEEKDAY] - 1,
        ScheduleArray[i][SCHEDDAY]
      );
      SpecialDay = CheckSchoolOff(SelectedDate, true);
      if (SpecialDay != "") {
        if (SpecialDay == "summer") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(230, 231, 233);
        } else if (SpecialDay == "first/last") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(244, 119, 33);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "winter/spring") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(87, 88, 90);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "publicholiday") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(68, 199, 238);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "personalday") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(76, 175, 86);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "operational") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(232, 184, 9);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "convention") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(238, 29, 35);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "dayinlieu") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(170, 96, 21);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        } else if (SpecialDay == "boardapproved") {
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.backgroundColor = RGB(102, 70, 147);
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.color = "#FFFFFF";
          DateGrid.cell(
            GridRow,
            ScheduleArray[i][SCHEDWEEKDAY] - 1
          ).style.fontWeight = "bold";
        }
      } else if (
        ScheduleArray[i][SCHEDWEEKDAY] == 1 ||
        ScheduleArray[i][SCHEDWEEKDAY] == 7
      ) {
        //Check for weekend
        DateGrid.cell(
          GridRow,
          ScheduleArray[i][SCHEDWEEKDAY] - 1
        ).style.backgroundColor = RGB(230, 231, 233);
      }
      if (
        Number(Left(SelectedDate, 4)) == Year(CDate(new Date())) &&
        Number(Mid(SelectedDate, 5, 2)) == Month(CDate(new Date())) &&
        Number(Right(SelectedDate, 2)) == Day(CDate(new Date()))
      ) {
        DateGrid.cell(
          GridRow,
          ScheduleArray[i][SCHEDWEEKDAY] - 1
        ).style.fontSize = "32px";
        DateGrid.cell(
          GridRow,
          ScheduleArray[i][SCHEDWEEKDAY] - 1
        ).style.fontStyle = "italic";
        DateGrid.cell(
          GridRow,
          ScheduleArray[i][SCHEDWEEKDAY] - 1
        ).style.fontWeight = "bold";
      }
      if (ScheduleArray[i][SCHEDWEEKDAY] == 7) {
        GridRow = GridRow + 1;
      }
    } else {
      break;
    }
  }
}

//Function CheckSchoolOff(SelectedDate,FirstLast)
//  Dim FirstLastDays          = ["20230905","20240626","20240903","20250625"]
//  Dim HolidayDays            = ["20230807","20230904","20230930","20231009","20231111","20231225","20231226","20240101","20240219","20240329","20240401","20240520","20240701","20240805","20240902","20240930","20241014","20241111","20241225","20241226","20250101","20250217","20250418","20250421","20250519","20250701"]
//  Dim PDDays                 = ["20230831","20230925","20231020","20231114","20240131","20240220","20240311","20240426","20240830","20241011","20241030","20241031","20250129","20250416","20250417","20250609"]
//  Dim OperationalDays        = ["20230901","20240621","20240627","20240829","20250626"]
//  Dim TeachersConventionDays = ["20240229","20240301","20250227","20250228"]
//  Dim TeachersDayInLieuDays  = ["20231109","20240521","20241101","20250521"]
//  Dim BoardApprovedDays      = ["20231110","20231113","20240522","20250520"]
//  Dim WinterSpringBreakDays  = ["20231227","20231228","20231229","20240102","20240103","20240104","20240105","20240325","20240326","20240327","20240328","20241223","20241224","20241227","20241230","20241231","20250102","20250103","20250324","20250325","20250326","20250327","20250328"]
//  CheckSchoolOff = ""
//  Dim j
//  For j = 0 To Len(HolidayDays)-1
//    If SelectedDate = HolidayDays[j] Then 'Check for public holiday
//      CheckSchoolOff = "publicholiday"
//      Exit Function
//    End If
//  Next
//  'Do this after publicholiday so Civic holiday and Canada day get picked up
//  If SelectedDate < FirstLastDays[0] Or (SelectedDate > FirstLastDays[1] And SelectedDate < FirstLastDays[2]) Or SelectedDate > FirstLastDays[3] Then 'Check for summer holidays
//    CheckSchoolOff = "summer"
//    Exit Function
//  End If
//  For j = 0 To Len(WinterSpringBreakDays)-1
//    If SelectedDate = WinterSpringBreakDays[j] Then 'Check for winter/spring break
//      CheckSchoolOff = "winter/spring"
//      Exit Function
//    End If
//  Next
//  For j = 0 To Len(PDDays)-1
//    If SelectedDate = PDDays[j] Then 'Check for personal days
//      CheckSchoolOff = "personalday"
//      Exit Function
//    End If
//  Next
//  For j = 0 To Len(OperationalDays)-1
//    If SelectedDate = OperationalDays[j] Then 'Check for operational day
//      CheckSchoolOff = "operational"
//      Exit Function
//    End If
//  Next
//  For j = 0 To Len(TeachersConventionDays)-1
//    If SelectedDate = TeachersConventionDays[j] Then 'Check for teachers' convention
//      CheckSchoolOff = "convention"
//      Exit Function
//    End If
//  Next
//  For j = 0 To Len(TeachersDayInLieuDays)-1
//    If SelectedDate = TeachersDayInLieuDays[j] Then 'Check for teachers' day in lieu
//      CheckSchoolOff = "dayinlieu"
//      Exit Function
//    End If
//  Next
//  For j = 0 To Len(BoardApprovedDays)-1
//    If SelectedDate = BoardApprovedDays[j] Then 'Check for board approved non-instructional day
//      CheckSchoolOff = "boardapproved"
//      Exit Function
//    End If
//  Next
//  If FirstLast Then
//    For j = 0 To Len(FirstLastDays)-1
//      If SelectedDate = FirstLastDays[j] Then 'Check for first/last day of school
//        CheckSchoolOff = "first/last"
//        Exit Function
//      End If
//    Next
//  End If
//end Function

Back1YearButton.onclick = function () {
  var NewSelectedYear;
  NewSelectedYear = SelectedYear - 1;
  if (
    NewSelectedYear < ScheduleArray[0][SCHEDYEAR] ||
    (NewSelectedYear == ScheduleArray[0][SCHEDYEAR] &&
      SelectedMonth < ScheduleArray[0][SCHEDMONTH])
  ) {
    //    SelectedYear = ScheduleArray[0][SCHEDYEAR]
    //    SelectedMonth = ScheduleArray[0][SCHEDMONTH]
    NSB.MsgBox(
      Months[ScheduleArray[0][SCHEDMONTH]] +
        ", " +
        ScheduleArray[0][SCHEDYEAR] +
        " is the earliest month"
    );
  } else {
    SelectedYear = NewSelectedYear;
  }
  DisplayScheduleForm();
};

Back1MonthButton.onclick = function () {
  var NewSelectedYear, NewSelectedMonth;
  NewSelectedMonth = SelectedMonth - 1;
  if (NewSelectedMonth < 1) {
    NewSelectedYear = SelectedYear - 1;
    NewSelectedMonth = 12;
  } else {
    NewSelectedYear = SelectedYear;
  }
  if (
    NewSelectedYear < ScheduleArray[0][SCHEDYEAR] ||
    (NewSelectedYear == ScheduleArray[0][SCHEDYEAR] &&
      NewSelectedMonth < ScheduleArray[0][SCHEDMONTH])
  ) {
    //    SelectedYear = ScheduleArray[0][SCHEDYEAR]
    //    SelectedMonth = ScheduleArray[0][SCHEDMONTH]
    NSB.MsgBox(
      Months[ScheduleArray[0][SCHEDMONTH]] +
        ", " +
        ScheduleArray[0][SCHEDYEAR] +
        " is the earliest month"
    );
  } else {
    SelectedYear = NewSelectedYear;
    SelectedMonth = NewSelectedMonth;
  }
  DisplayScheduleForm();
};

CurrentButton.onclick = function () {
  SelectedYear = Year(CDate(new Date()));
  SelectedMonth = Month(CDate(new Date()));
  DisplayScheduleForm();
};

Forward1YearButton.onclick = function () {
  var NewSelectedYear;
  NewSelectedYear = SelectedYear + 1;
  if (
    NewSelectedYear > ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] ||
    (NewSelectedYear == ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] &&
      SelectedMonth > ScheduleArray[Len(ScheduleArray) - 1][SCHEDMONTH])
  ) {
    //    SelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR]
    //    SelectedMonth = ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]
    NSB.MsgBox(
      Months[ScheduleArray[Len(ScheduleArray) - 1][SCHEDMONTH]] +
        ", " +
        ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] +
        " is the latest month"
    );
  } else {
    SelectedYear = NewSelectedYear;
  }
  DisplayScheduleForm();
};

Forward1MonthButton.onclick = function () {
  var NewSelectedYear, NewSelectedMonth;
  NewSelectedMonth = SelectedMonth + 1;
  if (NewSelectedMonth > 12) {
    NewSelectedYear = SelectedYear + 1;
    NewSelectedMonth = 1;
  } else {
    NewSelectedYear = SelectedYear;
  }
  if (
    NewSelectedYear > ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] ||
    (NewSelectedYear == ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] &&
      NewSelectedMonth > ScheduleArray[Len(ScheduleArray) - 1][SCHEDMONTH])
  ) {
    //    SelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR]
    //    SelectedMonth = ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]
    NSB.MsgBox(
      Months[ScheduleArray[Len(ScheduleArray) - 1][SCHEDMONTH]] +
        ", " +
        ScheduleArray[Len(ScheduleArray) - 1][SCHEDYEAR] +
        " is the latest month"
    );
  } else {
    SelectedYear = NewSelectedYear;
    SelectedMonth = NewSelectedMonth;
  }
  DisplayScheduleForm();
};

ContactsButton.onclick = function () {
  location.href = "https://epsb.ca/contact/";
};
var NoLocalStorage;
var ScreenWidth;
ScreenWidth = SysInfo(0);
var ScreenHeight;
ScreenHeight = SysInfo(1);